Attribute VB_Name = "Module2"
Option Explicit

Public Declare Function QueryPerformanceCounter Lib "Kernel32" (lpPerformanceCount As Currency) As Long
Public Declare Function QueryPerformanceFrequency Lib "Kernel32" (lpPerformanceCount As Currency) As Long

Public Declare Function SafeArrayGetDim Lib "oleaut32" (pArray() As Any) As Long

Public Declare Function GradientFillTriangle Lib "msimg32" Alias "GradientFill" (ByVal hDC As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_TRIANGLE, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long

Public TicksPerSecond As Currency
Public StartTime As Currency

Public Time As Single
Public InitialTime As Single
Public CurrentTime As Single
Public NewTime As Single
Public DeltaTime As Single
Public Accumulator As Single

Public Function GetElapsedTime() As Single
    
Dim LastTime As Currency
Dim CurrentTime As Currency

QueryPerformanceCounter CurrentTime
GetElapsedTime = (CurrentTime - LastTime) / TicksPerSecond
    
QueryPerformanceCounter LastTime
    
End Function

Public Function LockFPS(ByVal TargetFPS As Byte) As Single

Static LastTime As Currency
Dim CurrentTime As Currency
Dim FPS As Single

If TargetFPS = 0 Then TargetFPS = 1

LastTime = StartTime - 1

Do
    QueryPerformanceCounter CurrentTime
    If (CurrentTime - LastTime) <> 0 Then FPS = TicksPerSecond / (CurrentTime - LastTime)
    LockFPS = FPS

Loop While (FPS > TargetFPS)

LastTime = StartTime - 1
    
End Function


